/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.mappers.CityPlot;

import org.visnow.jscic.RegularField;
import static org.apache.commons.math3.util.FastMath.*;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class GUI extends javax.swing.JPanel
{

    private RegularField inField = null;
    private Params params = new Params();
    private float smax;

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
        dataComponentSelector.setTitle("graph component");
    }

    /**
     * This method is called from within the constructor to initialize the form. WARNING: Do NOT
     * modify this code. The content of this method is always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        jPanel3 = new javax.swing.JPanel();
        zeroBaseButton = new javax.swing.JRadioButton();
        minBaseButton = new javax.swing.JRadioButton();
        dataComponentSelector = new org.visnow.vn.lib.gui.DataComponentSelector();
        scaleSlider = new org.visnow.vn.gui.widgets.FloatSlider();
        jLabel1 = new javax.swing.JLabel();
        basePanel = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        xComponentUI = new org.visnow.vn.lib.gui.ComponentBasedUI.ComponentFeatureUI();
        xExtentSlider = new org.visnow.vn.gui.widgets.SubRangeSlider.SubRangeSlider();
        jPanel5 = new javax.swing.JPanel();
        yComponentUI = new org.visnow.vn.lib.gui.ComponentBasedUI.ComponentFeatureUI();
        yExtentSlider = new org.visnow.vn.gui.widgets.SubRangeSlider.SubRangeSlider();
        jPanel2 = new javax.swing.JPanel();

        setMinimumSize(new java.awt.Dimension(150, 580));
        setPreferredSize(new java.awt.Dimension(200, 600));
        setLayout(new java.awt.GridBagLayout());

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("graph type"));
        jPanel3.setLayout(new java.awt.GridBagLayout());

        buttonGroup1.add(zeroBaseButton);
        zeroBaseButton.setSelected(true);
        zeroBaseButton.setText("zero based");
        zeroBaseButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                zeroBaseButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanel3.add(zeroBaseButton, gridBagConstraints);

        buttonGroup1.add(minBaseButton);
        minBaseButton.setText("min based");
        minBaseButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                minBaseButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        jPanel3.add(minBaseButton, gridBagConstraints);

        dataComponentSelector.setPreferredSize(new java.awt.Dimension(200, 50));
        dataComponentSelector.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                dataComponentSelectorStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel3.add(dataComponentSelector, gridBagConstraints);

        scaleSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("graph scale"));
        scaleSlider.setMinimumSize(new java.awt.Dimension(180, 65));
        scaleSlider.setPreferredSize(new java.awt.Dimension(200, 65));
        scaleSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                scaleSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        jPanel3.add(scaleSlider, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(jPanel3, gridBagConstraints);

        jLabel1.setText("block relative dimension and position");
        jLabel1.setMaximumSize(new java.awt.Dimension(215, 25));
        jLabel1.setMinimumSize(new java.awt.Dimension(215, 25));
        jLabel1.setPreferredSize(new java.awt.Dimension(215, 25));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 3, 0, 0);
        add(jLabel1, gridBagConstraints);

        basePanel.setMinimumSize(new java.awt.Dimension(135, 150));
        basePanel.addComponentListener(new java.awt.event.ComponentAdapter()
        {
            public void componentShown(java.awt.event.ComponentEvent evt)
            {
                basePanelComponentShown(evt);
            }
        });
        basePanel.setLayout(new java.awt.GridBagLayout());

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("x"));
        jPanel4.setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel4.add(xComponentUI, gridBagConstraints);

        xExtentSlider.setPaintLabels(true);
        xExtentSlider.setPaintTicks(true);
        xExtentSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                xExtentSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(xExtentSlider, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        basePanel.add(jPanel4, gridBagConstraints);

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder("y"));
        jPanel5.setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel5.add(yComponentUI, gridBagConstraints);

        yExtentSlider.setPaintLabels(true);
        yExtentSlider.setPaintTicks(true);
        yExtentSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                yExtentSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel5.add(yExtentSlider, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        basePanel.add(jPanel5, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(basePanel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.3;
        add(jPanel2, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void scaleSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_scaleSliderStateChanged
        params.setAdjusting(scaleSlider.isAdjusting());
        params.setScale(scaleSlider.getVal());
        params.fireStateChanged();
    }//GEN-LAST:event_scaleSliderStateChanged

    private void dataComponentSelectorStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_dataComponentSelectorStateChanged
    {//GEN-HEADEREND:event_dataComponentSelectorStateChanged
        params.setComponent(dataComponentSelector.getComponent());
        setScaleMinMax();
        params.fireStateChanged();
    }//GEN-LAST:event_dataComponentSelectorStateChanged

    private void zeroBaseButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_zeroBaseButtonActionPerformed
    {//GEN-HEADEREND:event_zeroBaseButtonActionPerformed
        params.setZeroBased(zeroBaseButton.isSelected());
        params.fireStateChanged();
    }//GEN-LAST:event_zeroBaseButtonActionPerformed

    private void minBaseButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_minBaseButtonActionPerformed
    {//GEN-HEADEREND:event_minBaseButtonActionPerformed
        params.setZeroBased(zeroBaseButton.isSelected());
        params.fireStateChanged();
    }//GEN-LAST:event_minBaseButtonActionPerformed

    private void basePanelComponentShown(java.awt.event.ComponentEvent evt)//GEN-FIRST:event_basePanelComponentShown
    {//GEN-HEADEREND:event_basePanelComponentShown
        
    }//GEN-LAST:event_basePanelComponentShown

    private void xExtentSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_xExtentSliderStateChanged
    {//GEN-HEADEREND:event_xExtentSliderStateChanged
        if (!xExtentSlider.isAdjusting())
            params.setXRange(new float[] {xExtentSlider.getBottomValue() / 100f, 
                                          xExtentSlider.getTopValue() / 100f});
    }//GEN-LAST:event_xExtentSliderStateChanged

    private void yExtentSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_yExtentSliderStateChanged
    {//GEN-HEADEREND:event_yExtentSliderStateChanged
        if (!yExtentSlider.isAdjusting())
            params.setYRange(new float[] {yExtentSlider.getBottomValue() / 100f, 
                                          yExtentSlider.getTopValue() / 100f});
    }//GEN-LAST:event_yExtentSliderStateChanged

    public void setInField(RegularField inField)
    {
        params.setActive(false);
        if (inField.getDims() == null || inField.getDims().length != 2)
            return;
        this.inField = inField;
        dataComponentSelector.setDataSchema(inField.getSchema());
        params.setComponent(0);
        setScaleMinMax();
        params.setActive(true);
    }

    private void setScaleMinMax()
    {
        float min = (float)inField.getComponent(params.getComponent()).getPreferredMinValue();
        float max = (float)inField.getComponent(params.getComponent()).getPreferredMaxValue();
        int[] dims = inField.getDims();
        if (max <= min)
            max = min + .001f;
        long k = round(log10(.5 * (dims[0] + dims[1]) / (max - min)));
        smax = 10.f;
        if (k > 0)
            for (int i = 0; i < k; i++)
                smax *= 10;
        else
            for (int i = 0; i < -k; i++)
                smax /= 10;
        scaleSlider.setMin(-smax);
        scaleSlider.setMax(smax);
        scaleSlider.setVal(0.1f * smax);
        params.setScale(scaleSlider.getVal());
    }

    public void setParams(Params params)
    {
        this.params = params;
        xComponentUI.setComponentFeature(params.getxComponent());
        yComponentUI.setComponentFeature(params.getyComponent());
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel basePanel;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private org.visnow.vn.lib.gui.DataComponentSelector dataComponentSelector;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JRadioButton minBaseButton;
    private org.visnow.vn.gui.widgets.FloatSlider scaleSlider;
    private org.visnow.vn.lib.gui.ComponentBasedUI.ComponentFeatureUI xComponentUI;
    private org.visnow.vn.gui.widgets.SubRangeSlider.SubRangeSlider xExtentSlider;
    private org.visnow.vn.lib.gui.ComponentBasedUI.ComponentFeatureUI yComponentUI;
    private org.visnow.vn.gui.widgets.SubRangeSlider.SubRangeSlider yExtentSlider;
    private javax.swing.JRadioButton zeroBaseButton;
    // End of variables declaration//GEN-END:variables
}
